dnl ---=|=--- default.m4 ---=|=---
dnl ---=--- Default values for macros ---=---



dnl --- Pseudo-ASM compound instructions ---

defdef({AddIm},{Add($1,$2)})dnl
defdef({NOS},{point(DSP)})dnl
defdef({TSE},{point(DSP+DSINC)})dnl
defdef({Nip},{AddIm(DSP,DSINC)})dnl
defdef({PopData},{Mov($1,TOS)}__nl__{Mov(TOS,NOS)}__nl__{Nip})dnl
defdef({Mov},{ifelse({$1},,,{$2},,,{$1},{$2},,{__Mov__($1,$2)})})dnl
defdef({Movb},{ifelse({$1},,,{$2},,,{$1},{$2},,{__Movb__($1,$2)})})dnl
defdef({Movw},{ifelse({$1},,,{$2},,,{$1},{$2},,{__Movw__($1,$2)})})dnl
defdef({__Seq__},{ifelse({$*},,,{shift($@)},,{$1}{Terminator},
	        {$1}{Terminator}{Separator}{Seq(shift($@))})})dnl
defdef({Seq},{Begin}{__Seq__($@)}{End})dnl
defdef({Shr},{ifelse($2,,{__Shr__($1,1)},{__Shr__($1,$2)})})dnl
defdef({labelprefix},{Forth_})



dnl --- Defining a FORTH word ---

dnl  * to define a FORTH word,
dnl  * ....
dnl  * add an entry in a m4 table, so that we can later
dnl    simulate FORTH compilation from within m4,
dnl    provided the only meta-words used were built into the m4 files...
dnl ......

defdef({DefWord},
   {__DefWord__($@)})dnl



dnl --- Constant values ---
defdef({TRUE},{-1})	dnl -- Logical True value
defdef({FALSE},{0})	dnl -- Logical False value



dnl --- Deduced values ---
defdef({CHARSIZE},eval(1 << CHARABITS))dnl --	size of a char in bytes
defdef({WORDSIZE},eval(1 << WORDABITS))dnl --	size of a char in bytes
defdef({CELLSIZE},eval(1 << CELLABITS))dnl --	size of a cell in bytes
defdef({PAGESIZE},eval(1 << PAGEABITS))dnl --	size of a page in bytes
defdef({CHARMASK},eval(~ (CHARSIZE - 1)))dnl --	mask of chars in address
defdef({WORDMASK},eval(~ (WORDSIZE - 1)))dnl -- mask of words in address
defdef({CELLMASK},eval(~ (CELLSIZE - 1)))dnl -- mask of cells in address
defdef({PAGEMASK},eval(~ (PAGESIZE - 1)))dnl -- mask of pages in address
defdef({BITSPERCHAR},eval(CHARSIZE*BYTEBITS))dnl --	bits in a char
defdef({BITSPERCELL},eval(CELLSIZE*BYTEBITS))dnl --	bits in a cell
