include({choice.m4})

comment({	Portable implementation of the LLL kernel	})

comment({	The choice constructs will select the best	})
comment({	implementation ;-)				})




dnl ---------------------------- Comments -----------------------------------
dnl
dnl * Whenever a common interface can be found, move everything
dnl  from choices to macros defined in specialization files.
dnl
dnl * ANS Forth recommends TOS=hi, NOS=lo for double word set
dnl  we follow this recommendation.
dnl




dnl ------------------------- Defining Macros -------------------------------



define({DefBinOpWord},
{DefWord({$1},{$2},{$3})
   Enter
   $4(TOS,NOS)
   Nip
   Next
})

define({DefUnOpWord},
{DefWord({$1},{$2},{$3})
   Enter
   $4(TOS,$5)
   Nip
   Next
})




__codeseg__({



dnl -------- Integer Arithmetics ---------


DefBinOpWord(SWAP-,RSUB,,{Sub})
DefUnOpWord(2/,SHR,,{Shr},1)

DefWord(-,SUB)
	Neg(TOS)
DefBinOpWord(+,ADD,,{Add})


DefWord(>>,SHRN)
	Enter
	Mov(COUNT,TOS)
	PopData(TOS)
	Shr(TOS,COUNTLO)
	Next

DefWord(NEGATE)
	Enter
  Neg0:	Neg(TOS)
	Next


DefWord(ABS)
	Enter
choice({
    option({generic},{
	gotos(TOS,Neg0)
    })
    option({i386},{
	;Mov(eax,TOS)
	;CDQ
	;Xor(eax,edx)
	;Sub(eax,edx)
	;Mov(TOS,eax)
    })
    option({ANSIC},{
	if(TOS<0){TOS=-TOS};
    })
})
	Next


DefUnOpWord(1+,INC,,{Inc})




dnl ---------- Basic Multiplication operators ---------


DefWord(M*,m_star)
	Enter
choice({
    option({i386},{
	Mov(eax,NOS)
	imul TOS
	Mov(NOS,eax)
	Mov(TOS,edx)
    })
    option({ANSIC},{
	......
    })
    option({GCC},{
        sdCell Prod = TOS * NOS ;
	Mov(NOS,(Cell)Prod) ;
	Mov(TOS,(Cell)(Prod>>CELLABITS)) ;
    })
})
	Next


DefWord(UM*,u_m_star)
	Enter
choice({
    option({i386},{
	Mov(eax,NOS)
	mul TOS
	Mov(NOS,eax)
	Mov(TOS,edx)
    })
    option({ANSIC},{
	......
    })
    option({GCC},{
        udCell Prod = (uCell)TOS * (uCell)NOS ;
	Mov(NOS,(uCell)Prod) ;
	Mov(TOS,(uCell)(Prod>>CELLABITS)) ;
    })
})
	Next


DefWord(SM/REM,s_m_slash_rem)
	Enter
choice({
    option({i386},{
	Mov(edx,NOS)
	Nip
	Mov(eax,NOS)
	idiv(TOS)
	Mov(NOS,edx)	; remainder
	Mov(TOS,eax)	; quotient
    })
    option({ANSIC},{
	......
    })
    option({GCC},{
        sdCell D = (sdCell)(  (uCell)TOS | (uCell)(NOS<<CELLABITS)  );
	Mov(NOS,(Cell)(D % TOS)) ;
	Mov(TOS,(Cell)(D / TOS)) ;
    })
})
	Next


DefWord(UM/MOD,u_m_slash_mod)
	Enter
choice({
    option({i386},{
	Mov(edx,NOS)
	Nip
	Mov(eax,NOS)
	div(TOS)
	Mov(NOS,edx)	; remainder
	Mov(TOS,eax)	; quotient
    })
    option({ANSIC},{
	......
    })
    option({GCC},{
        udCell D = (udCell)(  (uCell)TOS | (uCell)(NOS<<CELLABITS)  );
	Mov(NOS,(uCell)(D % (uCell)TOS)) ;
	Mov(TOS,(uCell)(D / (uCell)TOS)) ;
    })
})
	Next


DefWord(FM/REM,s_m_slash_rem)
	Enter
choice({
    option({i386},{
	Mov(edx,NOS)
	Nip
	Mov(eax,NOS)
	idiv(TOS)
	Mov(NOS,edx)	; remainder
	Mov(TOS,eax)	; quotient
    })
    option({ANSIC},{
	......
    })
    option({GCC},{
        fdiv_t res = smdiv (num, denom);
        if (res.rem && (num.hi ^ denom) < 0)
        res.quot--, res.rem += denom;

        sdCell D = (sdCell)(  (uCell)TOS | (uCell)(NOS<<CELLABITS)  );
	Mov(NOS,(Cell)(D % TOS)) ;
	Mov(TOS,(Cell)(D / TOS)) ;
    })
})
	Next



dnl ------------ Pointer Arithmetics -------------

DefUnOpWord(CELL+,CELL_PLUS,,{Add},CELL)
DefUnOpWord(CELLS,,,{Shl},CELLABITS)




dnl ---------- Integer as boolean arrays Arithmetics ----------

DefUnOpWord(NOT,,,{Not})
DefAlias(INVERT,,,NOT)

DefBinOpWord(AND,,,{And})
DefBinOpWord(XOR,,,{Xor})
DefBinOpWord(OR,,,{Or})

DefAlias(FLAG,,,0NEQ)



dnl ---------------- USING POINTERS -----------------

DefWord(!,STO)
	Enter
	Mov(R0,NOS)
	Mov(point(TOS),R0)
	Mov(TOS,point(DSP,DSINC))
	AddIm(DSP,2*DSINC)
	Next

DefWord(@,LOD)
	Enter
	Mov(TOS,point(TOS))
	Next


DefWord(C!,CSTO)
	Enter
	Mov(R0,NOS)
	Movb(bytecast(point(TOS)),R0LL)
	Mov(TOS,point(DSP,DSINC))
	AddIm(DSP,2*DSINC)
	Next

DefWord(C@,CLOD)
	Enter
choice({
    option({i386},{
	movzx TOS,byte point(TOS)
    })
    option({generic},{
	Movb(TOSLL,bytecast(point(TOS)))
	And(TOS,~CHARMASK)
    })
})
	Next

DefWord(W!,WSTO)
	Enter
	Mov(R0,NOS)
	Movw(point(TOS),R0L)
	Mov(TOS,point(DSP,DSINC))
	AddIm(DSP,2*DSINC)
	Next

DefWord(W@,WLOD)
	Enter
choice({
    option({i386},{
	movzx TOS,word point(TOS)
    })
    option({generic},{
	Mov(TOSL,point(TOS))
	And(TOS,~WORDMASK)
    })
})
	Next




dnl ------------------------ NUMBER COMPARISON ------------------------------

dnl --- Equality ---

DefCompareWord0(0=,0EQ,,==,z)
DefCompareWord0(0<>,0NEQ,,!=,nz)

DefCompareWord(=,EQ,,==,z)
DefCompareWord(<>,NEQ,,!=,nz)


dnl --- Signed number comparison to zero ---

DefCompareWord0(0<,0LT,,<,s)
DefCompareWord0(0>=,0GE,,>=,ns)
DefCompareWord0(0>,0GT,,>,gt)
DefCompareWord0(0<=,0LE,,<=,le)

DefCompareWord(<,LT,,<,lt)
DefCompareWord(>=,GE,,>=,ge)
DefCompareWord(>,GT,,>,gt)
DefCompareWord(<=,LE,,<=,le)


dnl --- Unsigned number comparison to zero ---

DefCompareWord(U<,ULT,,<,b)
DefCompareWord(U>=,UGE,,>=,ae)
DefCompareWord(U>,UGT,,>,a)
DefCompareWord(U<=,ULE,,<=,be)




dnl --------------------------- CONSTANTS ------------------------------

define({DefConstWord},{
DefWord($1,$2)
	Enter
	PushData(ifelse($3,,$1,$3))
	Next
})

DefConstWord(-1,MINUS1)
DefConstWord(-2,MINUS2)
DefConstWord(-4,MINUS4)
DefConstWord({MAXINT},{MAXINT},MAXINT)
DefConstWord({MININT},{MININT},MININT)
DefConstWord(0,ZERO)
rept(31,{DefConstWord(i,PLUS{}i,i)})


dnl ----------------------- STACK MANIPULATION -------------------------

DefWord(SWAP)
	Enter
	Xchg(TOS,NOS)
	Next

DefWord(NOP)
	Enter
	Next

DefWord(OVER)
	Enter
	PushData
	Mov(TOS,point(DSP,1))
	Next

DefWord(DUP)
	Enter
	PushData(TOS)
	Next

DefWord(PICK)
	Enter
	Mov(TOS,point(DSP,TOS))
	Next

DefWord(ROT)
	Enter
	Mov(R0,NOS)
	Mov(NOS,TOS)
	Mov(TOS,point(DSP,1))
	Mov(point(DSP,1),R0)
	Next

DefWord(ROTROT)
	Enter
	Mov(R0,point(DSP,1))
	Mov(point(DSP,1),TOS)
	Mov(TOS,NOS)
	Mov(NOS,R0)
	Next


;;; DROP must follows

DefWord(DROP)
	Mov(TOS,NOS)
;;; NIP must follow

DefWord(NIP)
	Enter
	Nip
	Next



DefWord(ROLL)
dnl (!) Here we assume stacks grow down !!!
choice({
  option({ANSIC},{
	for (R0 = point(DSP,TOS) ;
	     TOS > 0;
	     TOS--)
	    point(DSP,TOS) = point(DSP,TOS-1) ;
	TOS = R0 ;
	})
  option({generic},{
	Mov(COUNT,TOS)
	Mov(R0,DSP)
	Mov(TOS,point(R0))
	Loop({
	   Add(R0,-DSPINC)
	   Xchg(TOS,point(R0))
	})
	})
})
	Enter
	Nip
	Next


DefWord(ROLLD)
dnl (!) Here we assume stacks grow down !!!
dnl (!) Here we assume stacks grow down !!!
choice({
  option({ANSIC},{
	for (R0 = point(DSP,TOS) ;
	     TOS > 0;
	     TOS--)
	    point(DSP,TOS) = point(DSP,TOS-1) ;
	TOS = R0 ;
	})
  option({i386},{
	mov ecx,TOS
	jecxz labelprefix{}DROP
	mov R0,DSP
	mov TOS,point(R0)
    cstk_roll_0:
	add R0,-DSPINC
	xchg TOS,point(R0)
	loop cstk_roll_0
	})
})
	Nip
	Next


DefWord(2DROP)
			mov TOS,point(esi+4)
			add esi,8
			Next
DefWord(2NIP)
			mov TOS,point(esi+4)
			mov eax,point(esi)
			add esi,8
			mov point(esi),eax
			Next
DefWord(2SWAP)
			xchg TOS,point(esi+4)
			mov eax,point(esi)
			xchg eax,point(esi+8)
			mov point(esi),eax
			Next
DefWord(2DUP)
			mov eax,point(esi)
			sub esi,8
			mov point(esi),eax
			mov point(esi+4),TOS
			Next
DefWord(2OVER)
			mov eax,point(esi+8)
			sub esi,8
			mov point(esi),eax
			mov point(esi+4),TOS
			mov TOS,point(esi+12)
			Next


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;; PROGRAM CONTROL, RET-based Threading ;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Words with different behaviour when using a control loop
;; for indirect threading or debugging
;; direct threading (no debugging control loop))
;;  point(esp) is just the direct code pointer
;;  point(ebp) is the environment pointer
;; environment is in

DefWord(R_ENV)
			lea TOS,point(ebp+4*TOS)
			Next

DefWord(R_IMM)
			sub esi,4
			mov point(esi),TOS
			pop TOS
			Next
DefWord(R_GOTO)
			mov esp,TOS
			mov TOS,point(esi)
			add esi,4
			Next
DefWord(R_BRZ)
			pop eax
			test TOS,TOS
			jnz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			add esp,eax
			Next
DefWord(R_BRNZ)
			pop eax
			test TOS,TOS
			jz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			add esp,eax
			Next
DefWord(R_BRA)
			pop eax
			add esp,eax
			Next
DefWord(R_SKIP)
			pop eax
			Next
DefWord(R_JZ)
			pop eax
			test TOS,TOS
			jnz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			mov esp,eax
			Next
DefWord(R_JNZ)
			pop eax
			test TOS,TOS
			jz short CSTK_R_DROP
			mov TOS,point(esi)
			add esi,4
			mov esp,eax
			Next
DefWord(R_JMP)
			pop esp
			Next
DefWord(R_BSR)
			pop eax
			add edi,4
			mov point(edi),esp
			add esp,eax
			Next
DefWord(R_JSR)
			pop eax
			add edi,4
			mov point(edi),esp
			mov esp,eax
			Next
DefWord(R_RET)
			mov esp,point(edi)
			sub edi,4
			Next


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;; PROGRAM CONTROL, Bytecode threading ;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Words with different behaviour when using a control loop
;; for indirect threading or debugging
;; Indirect threading)
;;  point(esp) is just the usual indirect threading routine
;;  point(ebp) is the bytecode pointer
;; environment is in point(esp+4)

DefWord(B_ENV)
			mov edx,point(esp+4)
			lea TOS,point(edx+TOS*4)
			Next
DefWord(B_IMM8)
			sub esi,4
			mov point(esi),TOS
			movzx TOS,point(BYTE ebp)
			inc ebp
			Next
DefWord(B_IMM16)
			sub esi,4
			mov point(esi),TOS
			movzx TOS,point(WO ebp)
			inc ebp
			Next
DefWord(B_IMM32)
			sub esi,4
			mov point(esi),TOS
			mov TOS,point(ebp)
			add ebp,4
			Next
DefWord(B_GOTO)
			mov esp,TOS
			mov TOS,point(esi)
			add esi,4
			Next
DefWord(B_BRZ)
			pop eax
			test TOS,TOS
			jnz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			add esp,eax
			Next
DefWord(B_BRA)
			pop eax
			add esp,eax
			Next
DefWord(B_SKIP)
			pop eax
			Next
DefWord(B_JZ)
			pop eax
			test TOS,TOS
			jnz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			mov esp,eax
			Next
DefWord(B_JMP)
			pop esp
			Next
DefWord(B_BSR)
			pop eax
			sub edi,4
			mov point(edi),esp
			add esp,eax
			Next
DefWord(B_JSR)
			pop eax
			sub edi,4
			mov point(edi),esp
			mov esp,eax
			Next
DefWord(B_RET)
			mov esp,point(edi)
			add edi,4
			Next

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;; EXECUTION CONTROL ;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DefWord(THREAD)
;			mov point(ebp+SAVE_SS),ss
;			mov point(ebp+SAVE_ESP),esp
;			mov ss,ds
			pop esp
			Next


	EXEC_MANY)
	;; executes ECX kernel instructions pointed at by EBX
			xchg TOS,esi
			mov edx,edi
			lea eax,point(ecx*4)
			sub esp,eax
			mov eax,point(TOS)
			@REPEAT
			  push eax
			  add TOS,4
			  mov eax,point(TOS)
			  or eax,eax
			@UNTIL z
			Next

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;; MULTITHREADING ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DefWord(PAUSE)
		AbsJmp CSTK_YIELD
DefWord(YIELD)

		mov point(BY CSTK_PAUSE),RETN_CODE


forget({
Not implemented:
#
#>
#S	number
'	tick

})
